package handlers

import (
	"log"
	"net/http"
	"time"

	"github.com/gorilla/mux"
)

func StartMainServer() {
	// Initialize Gorilla router
	router := mux.NewRouter()
	router.HandleFunc("/", indexGetHandler).Methods("GET")
	router.HandleFunc("/", indexPostHandler).Methods("POST")
	router.HandleFunc("/{key:[A-Za-z0-9-_]{4,}}", pasteGetHandler).Methods("GET")
	router.HandleFunc("/{key:[A-Za-z0-9-_]{4,}}/nr", pasteGetHandlerNoRedirect).Methods("GET")
	router.HandleFunc("/{key:[A-Za-z0-9-_]{4,}}/meta", pasteGetHandlerMeta).Methods("GET")

	srv := &http.Server{
		Handler:      router,
		Addr:         "127.0.0.1:8000",
		WriteTimeout: 15 * time.Second,
		ReadTimeout:  15 * time.Second,
	}
	log.Fatal(srv.ListenAndServe())
}
